Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.Console/3.3/HiveClientConsole.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.Console/3.3/HiveClientConsole.cs	(revision 4136)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Client.Console/3.3/HiveClientConsole.cs	(revision 4137)
@@ -109,5 +109,5 @@
 
     private void InitLogFileReader() {
-      logFileReader = new LogFileReader(Environment.CurrentDirectory + @"/Hive.log");
+      logFileReader = new LogFileReader(AppDomain.CurrentDomain.BaseDirectory + @"/Hive.Client.log");
       logFileReader.MoreData += new LogFileReader.MoreDataHandler(logFileReader_MoreData);
       logFileReader.Start();
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ExecutionEngineFacade.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ExecutionEngineFacade.cs	(revision 4136)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ExecutionEngineFacade.cs	(revision 4137)
@@ -59,5 +59,5 @@
 
     public ResponseObject<SerializedJob> GetLastSerializedResult(Guid jobId, bool requested, bool snapshot) {
-      using (contextFactory.GetContext()) {
+      using (contextFactory.GetContext(false)) {
         return jobManager.GetLastSerializedJobResultOf(jobId, requested, snapshot);
       }
@@ -65,5 +65,5 @@
 
     public ResponseObject<JobDto> GetJobById(Guid jobId) {
-      using (contextFactory.GetContext()) {
+      using (contextFactory.GetContext(false)) {
         return jobManager.GetJobById(jobId);
       }
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ServerConsoleFacade.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ServerConsoleFacade.cs	(revision 4136)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ServerConsoleFacade.cs	(revision 4137)
@@ -49,23 +49,21 @@
 
     public Response Login(string username, string password) {
-      using (contextFactory.GetContext()) {
-        Response resp = new Response();
-
-        sessionID = secMan.Login(username, password);
-        if (sessionID == Guid.Empty) {
-          resp.Success = false;
-          resp.StatusMessage = ApplicationConstants.RESPONSE_SERVERCONSOLE_LOGIN_FAILED;
-        } else {
-          resp.Success = true;
-          resp.StatusMessage =
-            ApplicationConstants.RESPONSE_SERVERCONSOLE_LOGIN_SUCCESS;
-        }
-        return resp;
-      }
+      Response resp = new Response();
+
+      sessionID = secMan.Login(username, password);
+      if (sessionID == Guid.Empty) {
+        resp.Success = false;
+        resp.StatusMessage = ApplicationConstants.RESPONSE_SERVERCONSOLE_LOGIN_FAILED;
+      } else {
+        resp.Success = true;
+        resp.StatusMessage =
+          ApplicationConstants.RESPONSE_SERVERCONSOLE_LOGIN_SUCCESS;
+      }
+      return resp;
     }
 
 
     public ResponseList<ClientDto> GetAllClients() {
-      using (contextFactory.GetContext()) {
+      using (contextFactory.GetContext(false)) {
         secMan.Authorize("AccessClients", sessionID, Guid.Empty);
         return clientManager.GetAllClients();
@@ -74,5 +72,5 @@
 
     public ResponseList<ClientGroupDto> GetAllClientGroups() {
-      using (contextFactory.GetContext()) {
+      using (contextFactory.GetContext(false)) {
         //secMan.Authorize("AccessClientGroup", sessionID, Guid.Empty);
         return clientManager.GetAllClientGroups();
@@ -81,5 +79,5 @@
 
     public ResponseList<UpTimeStatisticsDto> GetAllUpTimeStatistics() {
-      using (contextFactory.GetContext()) {
+      using (contextFactory.GetContext(false)) {
         secMan.Authorize("AccessStatistics", sessionID, Guid.Empty);
         return clientManager.GetAllUpTimeStatistics();
@@ -108,5 +106,5 @@
 
     public ResponseList<JobDto> GetAllJobs() {
-      using (contextFactory.GetContext()) {
+      using (contextFactory.GetContext(false)) {
         secMan.Authorize("AccessJobs", sessionID, Guid.Empty);
         return jobManager.GetAllJobs();
@@ -115,5 +113,5 @@
 
     public ResponseList<JobDto> GetAllJobsWithFilter(State jobState, int offset, int count) {
-      using (contextFactory.GetContext()) {
+      using (contextFactory.GetContext(false)) {
         secMan.Authorize("AccessJobs", sessionID, Guid.Empty);
         return jobManager.GetAllJobsWithFilter(jobState, offset, count);
@@ -122,5 +120,5 @@
 
     public ResponseObject<JobDto> GetJobById(Guid jobId) {
-      using (contextFactory.GetContext()) {
+      using (contextFactory.GetContext(false)) {
         secMan.Authorize("AccessJobs", sessionID, jobId);
         return jobManager.GetJobById(jobId);
@@ -129,5 +127,5 @@
 
     public ResponseObject<JobDto> GetJobByIdWithDetails(Guid jobId) {
-      using (contextFactory.GetContext()) {
+      using (contextFactory.GetContext(false)) {
         secMan.Authorize("AccessJobs", sessionID, jobId);
         return jobManager.GetJobByIdWithDetails(jobId);
@@ -143,5 +141,5 @@
 
     public ResponseObject<JobDto> GetLastJobResultOf(Guid jobId) {
-      using (contextFactory.GetContext()) {
+      using (contextFactory.GetContext(false)) {
         secMan.Authorize("AccessJobResults", sessionID, jobId);
         return jobManager.GetLastJobResultOf(jobId);
@@ -150,5 +148,5 @@
 
     public ResponseObject<SerializedJob> GetLastSerializedJobResultOf(Guid jobId, bool requested, bool snapshot) {
-      using (contextFactory.GetContext()) {
+      using (contextFactory.GetContext(false)) {
         secMan.Authorize("AccessJobResults", sessionID, jobId);
         return jobManager.GetLastSerializedJobResultOf(jobId, requested, snapshot);
@@ -157,5 +155,5 @@
 
     public ResponseList<JobResult> GetAllJobResults(Guid jobId) {
-      using (contextFactory.GetContext()) {
+      using (contextFactory.GetContext(false)) {
         secMan.Authorize("AccessJobResults", sessionID, jobId);
         return jobManager.GetAllJobResults(jobId);
@@ -185,5 +183,5 @@
 
     public ResponseObject<ClientGroupDtoList> GetAllGroupsOfResource(Guid resourceId) {
-      using (contextFactory.GetContext()) {
+      using (contextFactory.GetContext(false)) {
         secMan.Authorize("AccessUserGroup", sessionID, Guid.Empty);
         return clientManager.GetAllGroupsOfResource(resourceId);
@@ -199,5 +197,5 @@
 
     public ResponseList<ProjectDto> GetAllProjects() {
-      using (contextFactory.GetContext()) {
+      using (contextFactory.GetContext(false)) {
         secMan.Authorize("AccessProjects", sessionID, Guid.Empty);
         return jobManager.GetAllProjects();
@@ -227,5 +225,5 @@
 
     public ResponseList<JobDto> GetJobsByProject(Guid projectId) {
-      using (contextFactory.GetContext()) {
+      using (contextFactory.GetContext(false)) {
         secMan.Authorize("AccessJobs", sessionID, Guid.Empty);
         return jobManager.GetJobsByProject(projectId);
@@ -234,5 +232,5 @@
 
     public ResponseList<AppointmentDto> GetUptimeCalendarForResource(Guid guid) {
-      using (contextFactory.GetContext()) {
+      using (contextFactory.GetContext(false)) {
         return clientManager.GetUptimeCalendarForResource(guid);
       }
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Tracing/3.3/MethodCallPatternConverter.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Tracing/3.3/MethodCallPatternConverter.cs	(revision 4136)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Tracing/3.3/MethodCallPatternConverter.cs	(revision 4137)
@@ -11,9 +11,12 @@
       StackTrace callStack = new StackTrace();
       int i = 1;
-      while (i <= callStack.FrameCount && !callStack.GetFrame(i).GetMethod().DeclaringType.FullName.StartsWith("HeuristicLab.Hive")) {
+      while (i < callStack.FrameCount && !callStack.GetFrame(i).GetMethod().DeclaringType.FullName.StartsWith("HeuristicLab.Hive")) {
         i++; 
       }
-      StackFrame stack = new StackFrame(i);      
-      writer.Write(stack.GetMethod().Name);            
+      StackFrame stack = new StackFrame(i);
+      var method = stack.GetMethod();
+      if (method != null) {
+        writer.Write(stack.GetMethod().Name);
+      }
     }
   }