Index: trunk/sources/HeuristicLab.Core/3.3/Constraints/ComparisonConstraint.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Constraints/ComparisonConstraint.cs	(revision 4152)
+++ trunk/sources/HeuristicLab.Core/3.3/Constraints/ComparisonConstraint.cs	(revision 4153)
@@ -28,10 +28,8 @@
   [Item("ComparisonConstraint", "A constraint which checks for specified compare operation.")]
   public class ComparisonConstraint : Constraint {
-    public ComparisonConstraint()
-      : base() {
-    }
     [StorableConstructor]
-    protected ComparisonConstraint(bool deserializing) {
-    }
+    protected ComparisonConstraint(bool deserializing) : base(deserializing) { }
+
+    public ComparisonConstraint() : base() { }
     public ComparisonConstraint(IItem constrainedValue, ConstraintOperation comparisonOperation, object comparisonValue)
       : base(constrainedValue, comparisonOperation, comparisonValue) {
Index: trunk/sources/HeuristicLab.Core/3.3/Constraints/Constraint.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Constraints/Constraint.cs	(revision 4152)
+++ trunk/sources/HeuristicLab.Core/3.3/Constraints/Constraint.cs	(revision 4153)
@@ -29,11 +29,11 @@
   [StorableClass]
   public abstract class Constraint : Item, IConstraint {
+    [StorableConstructor]
+    protected Constraint(bool deserializing) : base(deserializing) { }
+
     protected Constraint() {
       this.Active = false;
       if (AllowedConstraintOperations != null && AllowedConstraintOperations.Count() != 0)
         this.ConstraintOperation = AllowedConstraintOperations.ElementAt(0);
-    }
-    [StorableConstructor]
-    protected Constraint(bool deserializing) {
     }
     protected Constraint(IItem constrainedValue, ConstraintOperation constraintOperation, object constraintData)
@@ -115,4 +115,7 @@
       return this.constrainedValue;
     }
+    protected abstract bool Check(object constrainedMember);
+    protected abstract bool Check(object constrainedMember, out string errorMessage);
+
     public bool Check() {
       if (!Active)
@@ -122,6 +125,4 @@
       return this.Check(constrainedMember);
     }
-    protected abstract bool Check(object constrainedMember);
-
     public bool Check(out string errorMessage) {
       errorMessage = string.Empty;
@@ -132,6 +133,4 @@
       return this.Check(constrainedMember, out errorMessage);
     }
-
-    protected abstract bool Check(object constrainedMember, out string errorMessage);
 
     #region events
Index: trunk/sources/HeuristicLab.Core/3.3/Constraints/ConstraintOperation.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Constraints/ConstraintOperation.cs	(revision 4152)
+++ trunk/sources/HeuristicLab.Core/3.3/Constraints/ConstraintOperation.cs	(revision 4153)
@@ -39,6 +39,5 @@
 
     [StorableConstructor]
-    protected ConstraintOperation(bool deserializing) {
-    }
+    protected ConstraintOperation(bool deserializing) { }
     protected ConstraintOperation(int value, string name) {
       this.value = value;
Index: trunk/sources/HeuristicLab.Core/3.3/Constraints/EqualityConstraint.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Constraints/EqualityConstraint.cs	(revision 4152)
+++ trunk/sources/HeuristicLab.Core/3.3/Constraints/EqualityConstraint.cs	(revision 4153)
@@ -28,10 +28,8 @@
   [Item("EqualityConstraint", "A constraint which checks for equality.")]
   public class EqualityConstraint : Constraint {
-    public EqualityConstraint()
-      : base() {
-    }
     [StorableConstructor]
-    protected EqualityConstraint(bool deserializing) {
-    }
+    protected EqualityConstraint(bool deserializing) : base(deserializing) { }
+
+    public EqualityConstraint() : base() { }
     public EqualityConstraint(IItem constrainedValue, ConstraintOperation constraintOperation, object constraintData)
       : base(constrainedValue, constraintOperation, constraintData) {
Index: trunk/sources/HeuristicLab.Core/3.3/Constraints/TypeCompatibilityConstraint.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Constraints/TypeCompatibilityConstraint.cs	(revision 4152)
+++ trunk/sources/HeuristicLab.Core/3.3/Constraints/TypeCompatibilityConstraint.cs	(revision 4153)
@@ -31,7 +31,5 @@
     }
     [StorableConstructor]
-    protected TypeCompatibilityConstraint(bool deserializing)
-      : base() {
-    }
+    protected TypeCompatibilityConstraint(bool deserializing) : base(deserializing) { }
     public TypeCompatibilityConstraint(IItem constrainedValue, ConstraintOperation constraintOperation, Type constraintData)
       : base(constrainedValue, constraintOperation, constraintData) {