Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive 3.3.sln
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive 3.3.sln	(revision 4136)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive 3.3.sln	(revision 4171)
@@ -8,4 +8,5 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Hive-3.3", "HeuristicLab.Hive\3.3\HeuristicLab.Hive-3.3.csproj", "{C92AAC8C-4D88-449C-ABA5-2B935D769842}"
 	ProjectSection(ProjectDependencies) = postProject
+		{CDAD2510-299C-4FA2-B351-9D71A5AF20B7} = {CDAD2510-299C-4FA2-B351-9D71A5AF20B7}
 		{AEB51212-CDBA-4FC6-A2EE-02359AA53ECE} = {AEB51212-CDBA-4FC6-A2EE-02359AA53ECE}
 		{55B89815-F3E7-4D09-9442-273F849141DD} = {55B89815-F3E7-4D09-9442-273F849141DD}
@@ -23,9 +24,7 @@
 		{D17A4D6A-4CAA-4470-8A19-F42463C021FD} = {D17A4D6A-4CAA-4470-8A19-F42463C021FD}
 		{42A1D075-6C12-4DD9-B0C2-C6F5210A8119} = {42A1D075-6C12-4DD9-B0C2-C6F5210A8119}
-		{679E977A-117B-456E-8594-2A4DEADB658B} = {679E977A-117B-456E-8594-2A4DEADB658B}
 		{9076697B-C151-46CD-95BC-1D059492B478} = {9076697B-C151-46CD-95BC-1D059492B478}
 		{5010BD86-23B7-4F8C-888A-76D21AD5266A} = {5010BD86-23B7-4F8C-888A-76D21AD5266A}
 		{4F15BEA2-F494-4584-A0E5-6BA85377B313} = {4F15BEA2-F494-4584-A0E5-6BA85377B313}
-		{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11} = {C8FEDAC1-0326-4293-B585-F0FEDDEDFC11}
 		{FD1AFEC2-7A79-45CF-9365-5195B04A2C9F} = {FD1AFEC2-7A79-45CF-9365-5195B04A2C9F}
 		{898B31CF-81DC-453B-AEB3-BDF83197A7EE} = {898B31CF-81DC-453B-AEB3-BDF83197A7EE}
@@ -61,6 +60,4 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Hive.Contracts-3.3", "HeuristicLab.Hive.Contracts\3.3\HeuristicLab.Hive.Contracts-3.3.csproj", "{134F93D7-E7C8-4ECD-9923-7F63259A60D8}"
 EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Hive.Engine-3.3", "HeuristicLab.Hive.Engine\3.3\HeuristicLab.Hive.Engine-3.3.csproj", "{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11}"
-EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Hive.Server-3.3", "HeuristicLab.Hive.Server\3.3\HeuristicLab.Hive.Server-3.3.csproj", "{A04AE929-D0E1-466D-A9D3-BF3C4B2C209F}"
 EndProject
@@ -70,6 +67,4 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Hive.Server.LINQDataAccess-3.3", "HeuristicLab.Hive.Server.LINQDataAccess\3.3\HeuristicLab.Hive.Server.LINQDataAccess-3.3.csproj", "{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Hive.Server.Scheduler-3.3", "HeuristicLab.Hive.Server.Scheduler\3.3\HeuristicLab.Hive.Server.Scheduler-3.3.csproj", "{679E977A-117B-456E-8594-2A4DEADB658B}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.DataAccess-3.3", "HeuristicLab.DataAccess\3.3\HeuristicLab.DataAccess-3.3.csproj", "{9076697B-C151-46CD-95BC-1D059492B478}"
@@ -294,20 +289,4 @@
 		{134F93D7-E7C8-4ECD-9923-7F63259A60D8}.Release|x86.ActiveCfg = Release|x86
 		{134F93D7-E7C8-4ECD-9923-7F63259A60D8}.Release|x86.Build.0 = Release|x86
-		{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11}.Debug|Mixed Platforms.ActiveCfg = Debug|x64
-		{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11}.Debug|Mixed Platforms.Build.0 = Debug|x64
-		{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11}.Debug|x64.ActiveCfg = Debug|x64
-		{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11}.Debug|x64.Build.0 = Debug|x64
-		{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11}.Debug|x86.ActiveCfg = Debug|x86
-		{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11}.Debug|x86.Build.0 = Debug|x86
-		{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11}.Release|Any CPU.Build.0 = Release|Any CPU
-		{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11}.Release|Mixed Platforms.ActiveCfg = Release|x64
-		{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11}.Release|Mixed Platforms.Build.0 = Release|x64
-		{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11}.Release|x64.ActiveCfg = Release|x64
-		{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11}.Release|x64.Build.0 = Release|x64
-		{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11}.Release|x86.ActiveCfg = Release|x86
-		{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11}.Release|x86.Build.0 = Release|x86
 		{A04AE929-D0E1-466D-A9D3-BF3C4B2C209F}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{A04AE929-D0E1-466D-A9D3-BF3C4B2C209F}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -372,20 +351,4 @@
 		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Release|x86.ActiveCfg = Release|x86
 		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}.Release|x86.Build.0 = Release|x86
-		{679E977A-117B-456E-8594-2A4DEADB658B}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{679E977A-117B-456E-8594-2A4DEADB658B}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{679E977A-117B-456E-8594-2A4DEADB658B}.Debug|Mixed Platforms.ActiveCfg = Debug|x64
-		{679E977A-117B-456E-8594-2A4DEADB658B}.Debug|Mixed Platforms.Build.0 = Debug|x64
-		{679E977A-117B-456E-8594-2A4DEADB658B}.Debug|x64.ActiveCfg = Debug|x64
-		{679E977A-117B-456E-8594-2A4DEADB658B}.Debug|x64.Build.0 = Debug|x64
-		{679E977A-117B-456E-8594-2A4DEADB658B}.Debug|x86.ActiveCfg = Debug|x86
-		{679E977A-117B-456E-8594-2A4DEADB658B}.Debug|x86.Build.0 = Debug|x86
-		{679E977A-117B-456E-8594-2A4DEADB658B}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{679E977A-117B-456E-8594-2A4DEADB658B}.Release|Any CPU.Build.0 = Release|Any CPU
-		{679E977A-117B-456E-8594-2A4DEADB658B}.Release|Mixed Platforms.ActiveCfg = Release|x64
-		{679E977A-117B-456E-8594-2A4DEADB658B}.Release|Mixed Platforms.Build.0 = Release|x64
-		{679E977A-117B-456E-8594-2A4DEADB658B}.Release|x64.ActiveCfg = Release|x64
-		{679E977A-117B-456E-8594-2A4DEADB658B}.Release|x64.Build.0 = Release|x64
-		{679E977A-117B-456E-8594-2A4DEADB658B}.Release|x86.ActiveCfg = Release|x86
-		{679E977A-117B-456E-8594-2A4DEADB658B}.Release|x86.Build.0 = Release|x86
 		{9076697B-C151-46CD-95BC-1D059492B478}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{9076697B-C151-46CD-95BC-1D059492B478}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -434,6 +397,6 @@
 		{21187322-52DD-4243-80A4-A85F0263E63B}.Release|x86.ActiveCfg = Release|x86
 		{21187322-52DD-4243-80A4-A85F0263E63B}.Release|x86.Build.0 = Release|x86
-		{55B89815-F3E7-4D09-9442-273F849141DD}.Debug|Any CPU.ActiveCfg = Debug|x86
-		{55B89815-F3E7-4D09-9442-273F849141DD}.Debug|Any CPU.Build.0 = Debug|x86
+		{55B89815-F3E7-4D09-9442-273F849141DD}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{55B89815-F3E7-4D09-9442-273F849141DD}.Debug|Any CPU.Build.0 = Debug|Any CPU
 		{55B89815-F3E7-4D09-9442-273F849141DD}.Debug|Mixed Platforms.ActiveCfg = Debug|x86
 		{55B89815-F3E7-4D09-9442-273F849141DD}.Debug|Mixed Platforms.Build.0 = Debug|x86
@@ -528,8 +491,6 @@
 		{4D5A2A16-66C2-431D-9AA3-BD3041E64B84} = {E7D8EFDA-B0CB-4B62-8EAE-2CF473F14D74}
 		{A4499DDD-D1B8-414F-98F6-903C2C71BEB0} = {E7D8EFDA-B0CB-4B62-8EAE-2CF473F14D74}
-		{679E977A-117B-456E-8594-2A4DEADB658B} = {E7D8EFDA-B0CB-4B62-8EAE-2CF473F14D74}
 		{898B31CF-81DC-453B-AEB3-BDF83197A7EE} = {E7D8EFDA-B0CB-4B62-8EAE-2CF473F14D74}
 		{134F93D7-E7C8-4ECD-9923-7F63259A60D8} = {84899895-AC52-4053-8A91-61753EF8E0A8}
-		{C8FEDAC1-0326-4293-B585-F0FEDDEDFC11} = {84899895-AC52-4053-8A91-61753EF8E0A8}
 		{21187322-52DD-4243-80A4-A85F0263E63B} = {84899895-AC52-4053-8A91-61753EF8E0A8}
 		{C92AAC8C-4D88-449C-ABA5-2B935D769842} = {84899895-AC52-4053-8A91-61753EF8E0A8}